#ifndef lint
static char *rcsid = "$Header: /scratch/fock/cvsroot/xd/xdgraph/src/drvGTOptions.c,v 2.11 1996/11/03 16:36:35 richter Rel $";
static char *copyright = "Copyright (c) 1995 The XD Group, Free University of Berlin. All rights reserved.";
#endif
/*
 * $Log: drvGTOptions.c,v $
 * Revision 2.11  1996/11/03 16:36:35  richter
 * -fill is now a style option
 *
 * Revision 2.10  1996/07/25  09:14:52  richter
 * new numbers because CV (emacs package) does not unterstand branches
 *
 * Revision 2.9.1.3  1996/07/25  06:18:21  richter
 * new options -black_bg -fill -cull
 *
 * Revision 2.9.1.2  1996/07/03  10:58:45  richter
 * implemented some options
 *
 * Revision 2.9.1.1  1996/05/20  11:22:57  richter
 * new driver performance command
 *
 * Revision 2.9  1996/04/09  15:54:28  richter
 * first ci for xdgraph (formerly xd2d)
 *
 * Revision 2.0  1995/05/12  11:54:06  richter
 * First semi-public beta release
 *
 *
 */

/*
 *======================================================================
 *
 * Module: drvGTOption
 *
 *======================================================================
 */

/*
 *----------------------------------------------------------------------
 * include files
 *----------------------------------------------------------------------
 */
#ifdef WIN32                    /* Cljf for Windows compilation        */
#include <windows.h>
#endif
#include "conf.h"		/* global configuration			*/
#include <GL/gl.h>  
#include <tk.h>                 /* Tk interface                         */
#include "xdgraph.h"		/* type definitions and array sizes	*/
#include "strProto.h"
#include "drvProto.h"

/*
 *----------------------------------------------------------------------
 * prototypes with internal linkage
 *----------------------------------------------------------------------
 */
static int showcfgDrvGT(Tcl_Interp *interp);

/*
 *----------------------------------------------------------------------
 * variables with external linkage
 *----------------------------------------------------------------------
 */
extern Tcl_Interp *interp;	/* the interpreter 			*/
struct {
    int twoside;
    int antialias;
    int flat;
    int depthcue;
    int performance;
    int culling;
    int black_bg;
    int configure_pending;
} gtdriver_options = {0, 0, 0, 1, 0, 0, 0};

/*
 *----------------------------------------------------------------------
 * variables with internal linkage
 *----------------------------------------------------------------------
 */
int
gtOptionsCmd(ClientData dummy,		/* nothing */
             Tcl_Interp *interp,	/* Current interpreter. */
             int argc,			/* Number of arguments. */
             char **argv)		/* Argument strings.	*/
{
    int i;
    
    if (argc <= 0) {
        return showcfgDrvGT(interp);
    }
    for (i=0; i<argc; ++i) {
        if (strEQ(argv[i], "-performance", 2)) {
            if (++i < argc) {
                if (Tcl_GetBoolean(interp, argv[i],
                                   &gtdriver_options.performance) != TCL_OK) {
                    return TCL_ERROR;
                }
            } else {
                Tcl_AppendResult(interp, "value for \"-performance\" missing",
                                 (char *) NULL);
            }
        } else if (strEQ(NULL, "-antialias", 2)) {
            if (++i < argc) {
                if (Tcl_GetBoolean(interp, argv[i],
                                   &gtdriver_options.antialias) != TCL_OK) {
                    return TCL_ERROR;
                }
            } else {
                Tcl_AppendResult(interp, "value for \"-antialias\" missing",
                                 (char *) NULL);
            }
        } else if (strEQ(NULL, "-black_bg", 1)) {
            if (++i < argc) {
                if (Tcl_GetBoolean(interp, argv[i],
                                   &gtdriver_options.black_bg) != TCL_OK) {
                    return TCL_ERROR;
                }
            } else {
                Tcl_AppendResult(interp, "value for \"-black_bg\" missing",
                                 (char *) NULL);
            }
        } else if (strEQ(NULL, "-cull", 2)) {
            if (++i < argc) {
                if (Tcl_GetBoolean(interp, argv[i],
                                   &gtdriver_options.culling) != TCL_OK) {
                    return TCL_ERROR;
                }
            } else {
                Tcl_AppendResult(interp, "value for \"-cull\" missing",
                                 (char *) NULL);
            }
        } else if (strEQ(NULL, "-depthcue", 2)) {
            if (++i < argc) {
                if (Tcl_GetBoolean(interp, argv[i],
                                   &gtdriver_options.depthcue) != TCL_OK) {
                    return TCL_ERROR;
                }
            } else {
                Tcl_AppendResult(interp, "value for \"-depthcue\" missing",
                                 (char *) NULL);
            }
        } else if (strEQ(NULL, "-flat", 3)) {
            if (++i < argc) {
                if (Tcl_GetBoolean(interp, argv[i],
                                   &gtdriver_options.flat) != TCL_OK) {
                    return TCL_ERROR;
                }
            } else {
                Tcl_AppendResult(interp, "value for \"-flat\" missing",
                                 (char *) NULL);
            }
        } else if (strEQ(NULL, "-twoside", 2)) {
            if (++i < argc) {
                if (Tcl_GetBoolean(interp, argv[i],
                                   &gtdriver_options.twoside) != TCL_OK) {
                    return TCL_ERROR;
                }
            } else {
                Tcl_AppendResult(interp, "value for \"-twoside\" missing",
                                 (char *) NULL);
            }
        }
    }
    gtdriver_options.configure_pending = 1;
    return TCL_OK;
}

static int
showcfgDrvGT(Tcl_Interp *interp)
{
    Tcl_DString cfg;

    Tcl_DStringInit(&cfg);

    Tcl_DStringStartSublist(&cfg);
    Tcl_DStringAppendElement(&cfg, "performance");
    Tcl_DStringAppendElement(&cfg, "flag");
    Tcl_DStringAppendElement(&cfg, "Performance Measurement");
    Tcl_DStringAppendElement(&cfg, "off");
    if (gtdriver_options.performance) {
        Tcl_DStringAppendElement(&cfg, "on");
    } else {
        Tcl_DStringAppendElement(&cfg, "off");
    }
    Tcl_DStringEndSublist(&cfg);
        
    Tcl_DStringStartSublist(&cfg);
    Tcl_DStringAppendElement(&cfg, "twoside");
    Tcl_DStringAppendElement(&cfg, "flag");
    Tcl_DStringAppendElement(&cfg, "Twosided Lighting");
    Tcl_DStringAppendElement(&cfg, "off");
    if (gtdriver_options.twoside) {
        Tcl_DStringAppendElement(&cfg, "on");
    } else {
        Tcl_DStringAppendElement(&cfg, "off");
    }
    Tcl_DStringEndSublist(&cfg);
        
    Tcl_DStringStartSublist(&cfg);
    Tcl_DStringAppendElement(&cfg, "antialias");
    Tcl_DStringAppendElement(&cfg, "flag");
    Tcl_DStringAppendElement(&cfg, "Antialiasing");
    Tcl_DStringAppendElement(&cfg, "off");
    if (gtdriver_options.antialias) {
        Tcl_DStringAppendElement(&cfg, "on");
    } else {
        Tcl_DStringAppendElement(&cfg, "off");
    }
    Tcl_DStringEndSublist(&cfg);
        
    Tcl_DStringStartSublist(&cfg);
    Tcl_DStringAppendElement(&cfg, "flat");
    Tcl_DStringAppendElement(&cfg, "flag");
    Tcl_DStringAppendElement(&cfg, "Flat Shading");
    Tcl_DStringAppendElement(&cfg, "off");
    if (gtdriver_options.flat) {
        Tcl_DStringAppendElement(&cfg, "on");
    } else {
        Tcl_DStringAppendElement(&cfg, "off");
    }
    Tcl_DStringEndSublist(&cfg);
    
    Tcl_DStringStartSublist(&cfg);
    Tcl_DStringAppendElement(&cfg, "black_bg");
    Tcl_DStringAppendElement(&cfg, "flag");
    Tcl_DStringAppendElement(&cfg, "Black Background");
    Tcl_DStringAppendElement(&cfg, "off");
    if (gtdriver_options.flat) {
        Tcl_DStringAppendElement(&cfg, "on");
    } else {
        Tcl_DStringAppendElement(&cfg, "off");
    }
    Tcl_DStringEndSublist(&cfg);
    
    Tcl_DStringStartSublist(&cfg);
    Tcl_DStringAppendElement(&cfg, "cull");
    Tcl_DStringAppendElement(&cfg, "flag");
    Tcl_DStringAppendElement(&cfg, "Backface Culling");
    Tcl_DStringAppendElement(&cfg, "off");
    if (gtdriver_options.culling) {
        Tcl_DStringAppendElement(&cfg, "on");
    } else {
        Tcl_DStringAppendElement(&cfg, "off");
    }
    Tcl_DStringEndSublist(&cfg);
    
    Tcl_DStringStartSublist(&cfg);
    Tcl_DStringAppendElement(&cfg, "depthcue");
    Tcl_DStringAppendElement(&cfg, "flag");
    Tcl_DStringAppendElement(&cfg, "Depth Cueing");
    Tcl_DStringAppendElement(&cfg, "on");
    if (gtdriver_options.depthcue) {
        Tcl_DStringAppendElement(&cfg, "on");
    } else {
        Tcl_DStringAppendElement(&cfg, "off");
    }
    Tcl_DStringEndSublist(&cfg);
        
    Tcl_DStringResult(interp, &cfg);
    return TCL_OK;
}
         
