#ifndef XD_DRVGTTYPES_H
#define XD_DRVGTTYPES_H
/*
 * Copyright (c) 1995 The XD Group, Free University of Berlin. All rights reserved.
 *
 * $Header: /scratch/fock/cvsroot/xd/xdgraph/src/drvGTTypes.h,v 2.11 1996/09/06 11:16:01 richter Rel $
 *
 * $Log: drvGTTypes.h,v $
 * Revision 2.11  1996/09/06 11:16:01  richter
 * many changes, most of this moved to the display list interface
 *
 * Revision 2.10  1996/07/25  09:14:52  richter
 * new numbers because CV (emacs package) does not unterstand branches
 *
 * Revision 2.9.1.2  1996/07/25  06:16:00  richter
 * color map and high/low cuttof on heightfields
 *
 * Revision 2.9.1.1  1996/05/20  11:22:10  richter
 * new display list object 'cylinder'
 *
 * Revision 2.9  1996/04/09  16:13:02  richter
 * first ci for xdgraph (formerly xd2d)
 *
 * Revision 2.0  1995/05/12  11:54:20  richter
 * First semi-public beta release
 *
 */

typedef struct {
    float rgb[3];
} GtColor;

typedef struct {
    float width;
} GtLinewidth;

typedef struct {
    int factor;
    unsigned short mask;
} GtLinestipple;

typedef struct gtlightS *GtlightP; /* */
typedef struct gtlightS {
    float position[4];		/* homogeneous coordinate */
    float ambient[4];		/* RGBA */
    float diffuse[4];		/* RGBA */
    float specular[4];		/* RGBA */
    
} GtlightT;

typedef struct gtstyleS *GtstyleP;
typedef struct gtstyleS {
    GtColor *color;
    GtLinewidth *linewidth;
    GtLinestipple *linestipple;
} GtstyleT;

typedef struct drvgtS *DrvgtP;
typedef struct drvgtS {
    GtlightT light[5];
    int lightnum;
    int  pixw, pixh;
    int  xlast, ylast;
    float xang, yang;
    float rotmat[16];
} DrvgtT;

#endif
