#ifndef XD_FOUTYPES_H
#define XD_FOUTYPES_H
/*
 * Copyright (c) 1995 The XD Group, Free University of Berlin. All rights reserved.
 *
 * $Header: /scratch/fock/cvsroot/xd/xdgraph/src/fouTypes.h,v 2.10 1996/07/25 09:14:52 richter Rel $
 *
 * $Log: fouTypes.h,v $
 * Revision 2.10  1996/07/25 09:14:52  richter
 * new numbers because CV (emacs package) does not unterstand branches
 *
 * Revision 2.9  1996/04/09  16:13:02  richter
 * first ci for xdgraph (formerly xd2d)
 *
 * Revision 2.0  1995/05/12  11:54:21  richter
 * First semi-public beta release
 *
 *
 */

typedef struct fourmapS *FourmapP;
typedef struct fourmapS {
    double dirmet[3][3];	/* metric tensor, direct space  */
    double rcpmet[3][3];	/* metric tensor, reciprocal space */
    double xcell, ycell, zcell; /* cell constants		*/
    double alpha, beta, gamma;	/* "				*/
    int    nx, ny, nz;		/* number of fmap points	*/
    double xran, yran, zran;	/* which fraction of the cell   */
    double xinc, yinc, zinc;	/* "				*/
    double ox, oy, oz;		/* "				*/
    double vmin, vmax;
    double *va;
} FourmapT;

typedef struct cellS *CellP;
typedef struct cellS {
    double dirmet[3][3];	/* metric tensor, direct space  */
    double rcpmet[3][3];	/* metric tensor, reciprocal space */
    double xcell, ycell, zcell; /* cell constants		*/
    double alpha, beta, gamma;	/* "				*/
} CellT;
   
#endif
