#ifndef lint
static char *rcsid = "$Header: /scratch/fock/cvsroot/xd/xdgraph/src/heiManager.c,v 2.11 1996/09/06 11:20:20 richter Rel $";
static char *copyright = "Copyright (c) 1995 The XD Group, Free University of Berlin. All rights reserved.";
#endif
/*
 * $Log: heiManager.c,v $
 * Revision 2.11  1996/09/06 11:20:20  richter
 * new 'tag' field (for the display list interface)
 *
 * Revision 2.10  1996/07/25  09:14:52  richter
 * new numbers because CV (emacs package) does not unterstand branches
 *
 * Revision 2.9.1.1  1996/07/25  06:16:36  richter
 * color map and high/low cutoff on heightfields
 *
 * Revision 2.9  1996/04/09  15:54:28  richter
 * first ci for xdgraph (formerly xd2d)
 *
 * Revision 2.0  1995/05/12  11:54:05  richter
 * First semi-public beta release
 *
 *
 */
/*
 *----------------------------------------------------------------------
 * include files
 *----------------------------------------------------------------------
 */
#include "conf.h"               /* global configuration                 */
#include "xdgraph.h"		/* type definitions and array sizes     */
#include "heiProto.h"
#include "namProto.h"
#include "pltProto.h"
#include "segProto.h"
#include "strProto.h"
#include "setProto.h"
#include "styProto.h"

HeightP
heiAlloc(char *name)
{
    HeightP hPtr;

    hPtr = (HeightP) ckalloc( sizeof(HeightT) );
    if (!hPtr) {
	Tcl_AppendResult(interp, "memory allocation error", NIL);
	return NULL;
    }

    heiClean(hPtr, FALSE);
    hPtr->name = strDupl(name);
    if (namAlloc("HEI", name, (void *)hPtr) != TCL_OK) {
        heiFree(&hPtr);
        hPtr = NULL;
    }

    return(hPtr);
}

void
heiClean(HeightP hPtr,
	 int old)
{
    if (!hPtr) return;

    styClean(&hPtr->style[0], old);
    styClean(&hPtr->style[1], old);

    if ( old ) {
	if (hPtr->name)   ckfree(hPtr->name);
	if (hPtr->map)    ckfree(hPtr->map);
	if (hPtr->view)   ckfree(hPtr->view);
	if (hPtr->object) ckfree(hPtr->object);
    }

    hPtr->name =   NULL;
    hPtr->flags =  0;
    hPtr->tag =    0;
    hPtr->plane =  0;
    hPtr->vertac = 1.;
    hPtr->hcut = hPtr->lcut = 0.;
    hPtr->map =    NULL;
    hPtr->view =   NULL;
    hPtr->object = NULL;
    return;
}

void
heiFree(HeightP *hei)
{
    HeightP hPtr;

    hPtr = *hei;
    if (!hPtr) return;

    namFree("HEI", hPtr->name);
   
    styClean(&hPtr->style[0], TRUE);
    styClean(&hPtr->style[1], TRUE);
    if (hPtr->name)   ckfree(hPtr->name);
    if (hPtr->map)    ckfree(hPtr->map);
    if (hPtr->view)   ckfree(hPtr->view);
    if (hPtr->object) ckfree(hPtr->object);
    ckfree( (char *)hPtr );
    *hei = (HeightP) NULL;
    return;
}

int
heiListByName(char *match)
{
    return namListByName("HEI", match);
}


HeightP
heiFindByName(char *name)
{
    return (HeightP) namFindByName("HEI", name);
}

