#ifndef XD_ISOPROTO_H
#define XD_ISOPROTO_H
/*
 * Copyright (c) 1995 The XD Group, Free University of Berlin. All rights reserved.
 *
 * $Header: /scratch/fock/cvsroot/xd/xdgraph/src/isoProto.h,v 2.12 1997/03/29 18:19:41 richter Rel $
 *
 * $Log: isoProto.h,v $
 * Revision 2.12  1997/03/29 18:19:41  richter
 * some functions are now static
 *
 * Revision 2.11  1996/11/03  16:26:40  richter
 * find_offset and interpolate are void, not int
 *
 * Revision 2.10  1996/07/25  09:14:52  richter
 * new numbers because CV (emacs package) does not unterstand branches
 *
 * Revision 2.9  1996/04/09  16:13:02  richter
 * first ci for xdgraph (formerly xd2d)
 *
 * Revision 2.0  1995/05/12  11:54:19  richter
 * First semi-public beta release
 *
 *
 */

/* isoCommand.c */
extern int IsosurfaceCmd(ClientData dummy, Tcl_Interp *interp, int argc, char **argv);
extern int IsosurfaceObjectCmd(ClientData data, Tcl_Interp *interp, int argc, char **argv);
/* isoEngine.c */
extern void isoEngine(GridP gPtr, IsosurfaceP iPtr);
/* isoManager.c */
extern IsosurfaceP isoAlloc(char *name);
extern void isoClean(IsosurfaceP iPtr, int old);
extern void isoFree(IsosurfaceP *iso);
extern int isoListByName(char *match);
extern IsosurfaceP isoFindByName(char *name);
extern SurfaceP srfAlloc(void);
extern void srfClean(SurfaceP srf, int old);
extern void srfAddTriangle(void *clientdata, double *v1, double *v2, double *v3, double *n1, double *n2, double *n3);
extern void srfFree(SurfaceP *srf);
extern void srfClearPlotFlag(SurfaceP srf);
extern void srfClearCalcFlag(SurfaceP srf);

#endif
