#ifndef XD_MOLTYPES_H
#define XD_MOLTYPES_H
/*
 * Copyright (c) 1995 The XD Group, Free University of Berlin. All rights reserved.
 *
 * $Header: /scratch/fock/cvsroot/xd/xdgraph/src/molTypes.h,v 2.12 1997/06/24 10:59:06 richter Rel $
 *
 * $Log: molTypes.h,v $
 * Revision 2.12  1997/06/24 10:59:06  richter
 * *** empty log message ***
 *
 * Revision 2.12  1997/06/23 19:19:41  richter
 * added options to suppress atom, bond or label plot
 *
 * Revision 2.11  1996/07/28  11:44:15  richter
 * new default styles (removed from datasets)
 * new tags (for display lists)
 * renamed objects to atoms and connections to bonds
 *
 * Revision 2.10  1996/07/25  09:14:52  richter
 * new numbers because CV (emacs package) does not unterstand branches
 *
 * Revision 2.9.1.1  1996/07/03  14:31:39  richter
 * removed scale
 *
 * Revision 2.9  1996/04/09  16:13:02  richter
 * first ci for xdgraph (formerly xd2d)
 *
 * Revision 2.0  1995/05/12  11:54:28  richter
 * First semi-public beta release
 *
 *
 */

typedef struct moleculeS *MoleculeP;
typedef struct moleculeS {
    char    *name;		/* molecule command name	*/
    double  zlimit;
    ObjectP atoms;
    ConnP   bonds;
    StyleT  def_atom_style;
    StyleT  def_bond_style;
    StyleT  def_label_style;
    int     do_atoms, do_labels, do_bonds;
    int     num_atom_tags, num_label_tags, num_bond_tags;
    int     *atom_tag;
    int     *label_tag;
    int     *bond_tag;
    char    *set;
    char    *view;
} MoleculeT;

#endif
