#ifndef lint
static char *rcsid = "$Header: /scratch/fock/cvsroot/xd/xdgraph/src/pthManager.c,v 2.11 1996/09/06 11:35:29 richter Rel $";
static char *copyright = "Copyright (c) 1995 The XD Group, Free University of Berlin. All rights reserved.";
#endif
/*
 * $Log: pthManager.c,v $
 * Revision 2.11  1996/09/06 11:35:29  richter
 * new 'tag' field (for the display list interface)
 *
 * Revision 2.10  1996/07/25  09:14:52  richter
 * new numbers because CV (emacs package) does not unterstand branches
 *
 * Revision 2.9.1.2  1996/07/03  10:02:54  richter
 * *** empty log message ***
 *
 * Revision 2.9.1.1  1996/05/19  15:59:09  richter
 * view transforms, not path
 *
 * Revision 2.9  1996/04/09  15:54:28  richter
 * first ci for xdgraph (formerly xd2d)
 *
 * Revision 2.0  1995/05/12  11:54:10  richter
 * First semi-public beta release
 *
 *
 */
/*
 *----------------------------------------------------------------------
 * include files
 *----------------------------------------------------------------------
 */
#include "conf.h"               /* global configuration                 */
#include "xdgraph.h"               /* type definitions and array sizes     */
#include "pthProto.h"
#include "namProto.h"
#include "segProto.h"
#include "strProto.h"
#include "styProto.h"

PathP
pthAlloc(char *name)
{
    PathP pPtr;

    pPtr = (PathP) ckalloc( sizeof(PathT) );
    if (!pPtr) {
	Tcl_AppendResult(interp, "memory allocation error", (char *) NULL);
	return NULL;
    }

    pthClean(pPtr, FALSE);
    pPtr->name  = strDupl(name);
    if (namAlloc("PTH", name, (void *)pPtr) != TCL_OK) {
        pthFree(&pPtr);
        pPtr = NULL;
    }
    
    return pPtr;

}

void
pthClean(PathP pPtr,
	 int old)
{
    if (!pPtr) return;

    styClean(&pPtr->style, old);

    if (old) {
	if (pPtr->name) ckfree(pPtr->name);
	if (pPtr->view)  ckfree(pPtr->view);
	if (pPtr->set)  ckfree(pPtr->set);
    }

    pPtr->path  = NULL;
    pPtr->objects = NULL;
    pPtr->view   = NULL;
    pPtr->set   = NULL;

}

void
pthFree(PathP *pth)
{
    PathP pPtr;

    pPtr = *pth;
    if (!pPtr) return;

    namFree("PTH", pPtr->name);
    styClean(&pPtr->style, TRUE);

    if (pPtr->name) ckfree(pPtr->name);
    if (pPtr->view)  ckfree(pPtr->view);
    if (pPtr->set)  ckfree(pPtr->set);
    ckfree((char *)pPtr);
    *pth = NULL;
    return;
}

int
pthListByName(char *match)
{
    return namListByName("PTH", match);
}


PathdataP
pthdataAlloc(int oid,
	     char *type,
	     int np)
{
    PathdataP pPtr;

    pPtr = (PathdataP) ckalloc( sizeof(PathT) );
    pPtr->tag   = 0;
    pPtr->oid   = oid;
    pPtr->type  = strDupl(type);
    pPtr->seg   = segAlloc(np, 0);
    pPtr->next  = NULL;
    return(pPtr);
}

void
pthdataFree(PathdataP *pth)
{
    PathdataP pPtr;

    pPtr = *pth;

    if (pPtr->type)  ckfree(pPtr->type);
    if (pPtr->seg)   segFree(&pPtr->seg);
    if (pPtr->next)  pthdataFree(&pPtr->next);

    ckfree((char *)pPtr);
    *pth = NULL;
    return;
}
