#ifndef XD_SEGTYPES_H
#define XD_SEGTYPES_H
/*
 * Copyright (c) 1995 The XD Group, Free University of Berlin. All rights reserved.
 *
 * $Header: /scratch/fock/cvsroot/xd/xdgraph/src/segTypes.h,v 2.10 1996/07/25 09:14:52 richter Rel $
 *
 * $Log: segTypes.h,v $
 * Revision 2.10  1996/07/25 09:14:52  richter
 * new numbers because CV (emacs package) does not unterstand branches
 *
 * Revision 2.9.1.1  1996/05/19  16:07:09  richter
 * more segment types
 *
 * Revision 2.9  1996/04/09  16:13:02  richter
 * first ci for xdgraph (formerly xd2d)
 *
 * Revision 2.0  1995/05/12  11:54:27  richter
 * First semi-public beta release
 *
 *
 */

/*
 * 2-Dimensional Coordinates
 */
typedef struct c2dS {
    double x, y;
} c2dT;

/*
 * 3-Dimensional Coordinates
 */
typedef struct c3dS {
    double x, y, z;
} c3dT;

/*
 * Line Segments
 * Those are allocated in chunks of 'segmentAlloc', the chunks beeing
 * stored in a (singly) linked list.  The anchor is usually the corresponding
 * level structure
 */
typedef enum {
    INVALIDSEG,			/* structure just initialized		*/
    MOVESEG,			/* move to first point			*/
    DRAWSEG,			/* draw line to first point
				   should always be preceded by MOVESEG */
    LINESET,
    POINTSET
} SegmentE;

typedef struct segmentS *SegmentP;
typedef struct segmentS {
    SegmentE type;		/* type of this chunk			*/
    int      alloc;		/* number of points allocated		*/
    int      np;		/* number of points used		*/
    union {
        c3dT *point;
        struct {
            c3dT *a, *b;
        } line;
    } p;
    SegmentP next;		/* link to next chunk			*/
} SegmentT;

#endif
