#ifndef XD_STYPROTO_H
#define XD_STYPROTO_H
/*
 * Copyright (c) 1995 The XD Group, Free University of Berlin. All rights reserved.
 *
 * $Header: /scratch/fock/cvsroot/xd/xdgraph/src/styProto.h,v 2.13 1997/03/29 18:16:09 richter Rel $
 *
 * $Log: styProto.h,v $
 * Revision 2.13  1997/03/29 18:16:09  richter
 * styFillAnchor and styFillLinewidth changed from void to int
 *
 * Revision 2.12  1996/11/03  16:25:49  richter
 * added styApplyPolygon and styFillPolygon
 * styGetConfig got a mask argument
 *
 * Revision 2.11  1996/09/06  11:58:40  richter
 * *** empty log message ***
 *
 * Revision 2.10  1996/07/25  09:14:52  richter
 * new numbers because CV (emacs package) does not unterstand branches
 *
 * Revision 2.9.1.2  1996/07/03  10:09:51  richter
 * re-organized
 *
 * Revision 2.9.1.1  1996/05/19  16:08:11  richter
 * *** empty log message ***
 *
 * Revision 2.9  1996/04/09  16:13:02  richter
 * first ci for xdgraph (formerly xd2d)
 *
 * Revision 2.0  1995/05/12  11:54:30  richter
 * First semi-public beta release
 *
 *
 */

/* styApplyManager.c */
extern int styApply(StyleP out, int *out_mask, StyleP current, StyleP in, int in_mask);
extern int styApplyForeground(StyleP out, int *out_mask, StyleP cur, int fgnam, char *name, int fgmod, ColorE model, int fgval, float val[3]);
extern int styApplyLine(StyleP out, int *out_mask, StyleP cur, int lnwid, double width, int lnpat, int plength, double *pattern);
extern int styApplyPolygon(StyleP out, int *out_mask, StyleP cur, int pgmode, PolygonE mode);
extern int styApplyFont(StyleP out, int *out_mask, StyleP cur, int fosiz, double size, int fonam, char *name, int foanc, char *anchor);
/* styCvtManager.c */
extern void styLoadColorname(char *name);
extern void styCvtColorname(ColorT *col);
extern int styLoadColormap(int id, char *file);
extern int styCvtindex2rgb(int id, int icol, float *r, float *g, float *b);
extern float max3(float a, float b, float c);
extern float min3(float a, float b, float c);
extern void styCvtrgb2hsv(float r, float g, float b, float *h, float *s, float *v);
extern void styCvthsv2rgb(float h, float s, float v, float *r, float *g, float *b);
extern void styCvtyuv2rgb(float y, float u, float v, float *r, float *g, float *b);
extern void styCvtrgb2yuv(float r, float g, float b, float *y, float *u, float *v);
/* styFillManager.c */
extern int styFillPolygon(Tcl_Interp *interp, StyleP sPtr, char *string);
extern int styFillAnchor(Tcl_Interp *interp, StyleP sPtr, char *anchor);
extern int styFillLinewidth(Tcl_Interp *interp, StyleP sPtr, double value);
extern int styFillPattern(Tcl_Interp *interp, StyleP sPtr, char *sstring);
extern int styFillFG(Tcl_Interp *interp, StyleP sty, char *col);
extern int styFillInterpol(Tcl_Interp *interp, StyleP sty, int step, int max, StyleP from, StyleP to);
/* styManager.c */
extern void styClean(StyleP sPtr, int old);
extern int styGetConfig(Tcl_DString *o, StyleP sPtr, int mask, int has_2nd, int onoff_2nd, StyleP sPtr2);
extern int styGetConfigForeground(Tcl_DString *o, StyleP sPtr);
extern int styParseArgs(int *argc, char **argv, StyleP style1, StyleP style2, int *has2styles);
extern int styLoadElements(Tcl_Interp *interp, char *file);
extern char *styGetElementFG(char *key);
extern double styGetElementRadius(char *key);

#endif
