#ifndef XD_STYTYPES_H
#define XD_STYTYPES_H
/*
 * Copyright (c) 1995 The XD Group, Free University of Berlin. All rights reserved.
 *
 * $Header: /scratch/fock/cvsroot/xd/xdgraph/src/styTypes.h,v 2.13 1996/11/28 13:35:18 richter Rel $
 *
 * $Log: styTypes.h,v $
 * Revision 2.13  1996/11/28 13:35:18  richter
 * use parenthese around shift expressions
 * corrected STY_FONT_* macros
 *
 * Revision 2.12  1996/11/03  16:41:52  richter
 * the STY_group_thingy defines are more easily changed now
 * added a PolygonT
 *
 * Revision 2.11  1996/09/06  11:59:11  richter
 * define mask values for styApply
 *
 * Revision 2.10  1996/07/25  09:14:52  richter
 * new numbers because CV (emacs package) does not unterstand branches
 *
 * Revision 2.9.1.1  1996/05/19  16:08:25  richter
 * new color model 'UNKNOWNMODEL'
 *
 * Revision 2.9  1996/04/09  16:13:02  richter
 * first ci for xdgraph (formerly xd2d)
 *
 * Revision 2.0  1995/05/12  11:54:31  richter
 * First semi-public beta release
 *
 *
 */

#define NCOLMODELS 5
typedef enum colorE {
    UNKNOWNMODEL, RGBMODEL, HSVMODEL, YUVMODEL, MAPMODEL
} ColorE;

#define STY_FG_BASE      0
#define STY_FG_NAME      (0x1 << STY_FG_BASE)
#define STY_FG_MODEL     (0x1 << (STY_FG_BASE+1))
#define STY_FG_VALUE     (0x1 << (STY_FG_BASE+2))
#define STY_FG_ALL       (STY_FG_NAME | STY_FG_MODEL | STY_FG_VALUE)

#define STY_LINE_BASE    (STY_FG_BASE+3)
#define STY_LINE_WIDTH   (0x1 << STY_LINE_BASE)
#define STY_LINE_PATTERN (0x1 << (STY_LINE_BASE+1))
#define STY_LINE_ALL     (STY_LINE_WIDTH | STY_LINE_PATTERN)

#define STY_FONT_BASE    (STY_LINE_BASE+2)
#define STY_FONT_SIZE    (0x1 << STY_FONT_BASE)
#define STY_FONT_NAME    (0x1 << (STY_FONT_BASE+1))
#define STY_FONT_ANCHOR  (0x1 << (STY_FONT_BASE+2))
#define STY_FONT_ALL     (STY_FONT_SIZE | STY_FONT_NAME)
/* yes, STY_FONT_ALL is without ANCHOR */

#define STY_POLYGON_BASE (STY_FONT_BASE+3)
#define STY_POLYGON_MODE (0x1 << STY_POLYGON_BASE)
#define STY_POLYGON_ALL  (STY_POLYGON_MODE)

#define STY_ALL          (STY_FG_ALL |\
                          STY_LINE_ALL |\
                          STY_FONT_ALL | STY_FONT_ANCHOR |\
                          STY_POLYGON_ALL)

typedef struct colorS *ColorP;
typedef struct colorS {
    char   *name;
    ColorE model;
    float  val[3];
} ColorT;

typedef struct lineS *LineP;
typedef struct lineS {
    double width;
    int    plength;
    double *pattern;
    char *verbal;
} LineT;

typedef struct fontS *FontP;
typedef struct fontS {
    double size;
    char   *name;
    char   *anchor;
} FontT;

typedef enum polygonE {PG_POINT, PG_LINE, PG_FILL} PolygonE;

typedef struct polygonS *PolygonP;
typedef struct polygonS {
    PolygonE  mode;
} PolygonT;

typedef struct styleS *StyleP;
typedef struct styleS {
    ColorT   fg;
    LineT    line;
    FontT    font;
    PolygonT pg;
} StyleT;

#endif
