#ifndef XD_VIETYPES_H
#define XD_VIETYPES_H
/*
 * Copyright (c) 1995 The XD Group, Free University of Berlin. All rights reserved.
 *
 * $Header: /scratch/fock/cvsroot/xd/xdgraph/src/vieTypes.h,v 2.11 1996/07/28 11:41:09 richter Rel $
 *
 * $Log: vieTypes.h,v $
 * Revision 2.11  1996/07/28 11:41:09  richter
 * new display list pointer: dl_current
 *
 * Revision 2.10  1996/07/25  09:14:52  richter
 * new numbers because CV (emacs package) does not unterstand branches
 *
 * Revision 2.9.1.3  1996/07/25  07:20:39  richter
 * started to work on display lists
 * playing with VC in emacs
 *
 * Revision 2.9.1.2  1996/07/03  10:07:11  richter
 * vrange
 *
 * Revision 2.9.1.1  1996/05/19  16:04:39  richter
 * new view types
 * view options (transformation)
 *
 * Revision 2.9  1996/04/09  16:13:02  richter
 * first ci for xdgraph (formerly xd2d)
 *
 * Revision 2.0  1995/05/12  11:54:19  richter
 * First semi-public beta release
 *
 *
 */

typedef struct objlistS *ObjlistP;
typedef struct objlistS {
    char *name;
    char *type;
    ObjlistP next, prev;
} ObjlistT;

typedef enum {VIEW_UNKNOWN, VIEW_XYDIAG, VIEW_CONTOUR, VIEW_RELIEF, VIEW_PATH,
              VIEW_HEIGHT, VIEW_SURFACE} ViewE;

typedef struct {
    double scale;
    double orig[3], trans[3];
    double rotm[3][3];
    double width, height;
    double vrange[2];
    int doscale, doorig, dotrans, dorot;
} ViewOptT;

typedef struct viewS *ViewP;
typedef struct viewS {
    char   *name;             /* view name                        */
    ViewE  type;
    ViewOptT opt;
    StyleT style;             /* currently active style           */
    ObjlistP  head, tail;     /* objects registered with this view */
    DLobjP dl_head, dl_current, dl_tail;
    void   *drdat;            /* driver dependent data            */
    int (*drproc)(void *, Tcl_Interp *interp, int argc, char **argv);
} ViewT;

#endif
